----------------------------------------------------------------------------
--------------------"The simplest design is always the best design." -------
---@v1.1.0.3----------------------------------------------------------------
----------------------------------------------------------------------------
-- Copyright (C)ViperGTS96, Confidential, All Rights Reserved.--------------
----------------------------------------------------------------------------

source(Utils.getFilename("snowFX.lua", g_currentModDirectory));

snowFXRegister = {};
snowFXRegister.modDirectory = g_currentModDirectory;

local modDesc = loadXMLFile("modDesc", g_currentModDirectory .. "modDesc.xml");
snowFXRegister.version = getXMLString(modDesc, "modDesc.version");

function installSpec()
	if g_specializationManager:getSpecializationByName("snowFX") == nil then
		if snowFX == nil then 
			print("ERROR: unable to find source file 'snowFX'");
		else 
			for typeName, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and (typeName ~= "locomotive") then 
					local isWashable = false;
					local isAnimated = false;
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "washable" then 
							isWashable = true;
						elseif name == "animatedVehicle" then 
							isAnimated = true;
						end;
					end;
					if isWashable and isAnimated then
						typeDef.specializationsByName["snowFX"] = snowFX;
						table.insert(typeDef.specializationNames, "snowFX");
						table.insert(typeDef.specializations, snowFX);
					end;
				end;
			end;
		end;	
	end;
end;

function snowFXRegister:incompatible()
	local incompatible = g_modIsLoaded["FS19_RM_Seasons"];
	return incompatible;
end;

if not snowFXRegister:incompatible() then
	VehicleTypeManager.validateVehicleTypes = Utils.prependedFunction(VehicleTypeManager.validateVehicleTypes, installSpec);
else
	snowFX:disable()
end;
snowFX:setDir(snowFXRegister.modDirectory);