----------------------------------------------------------------------------
----Author: ViperGTS96-----------------------------------------------------
----------------------------------------------------------------------------
--------------------"The simplest design is the best design." --------------
----------------------------------------------------------------------------

JustSnow = {}
JustSnow.dir = g_currentModDirectory;
local modDescFile = loadXMLFile("modDesc", JustSnow.dir .. "modDesc.xml");
local jsSettingsFile = loadXMLFile("jsSettingsFile", JustSnow.dir .. "settings.xml");
JustSnow.title = getXMLString(modDescFile, "modDesc.title.en");
JustSnow.author = getXMLString(modDescFile, "modDesc.author");
JustSnow.version = getXMLString(modDescFile, "modDesc.version");
JustSnow.loadSalt = true;--Utils.getNoNil(getXMLBool(jsSettingsFile, "settings.loadSalt"),true);
JustSnow.cutGrass = Utils.getNoNil(getXMLBool(jsSettingsFile, "settings.cutGrass"),false);
JustSnow.fullCPULoad = Utils.getNoNil(getXMLBool(jsSettingsFile, "settings.fullCPULoad"),false);
delete(modDescFile);
delete(jsSettingsFile);
JustSnow.x = 0;
JustSnow.z = 0;
JustSnow.yBoost = 0.18;
JustSnow.terrainSize = 0;
JustSnow.tipsPerTic = 4;
JustSnow.totalDrops = 0;
JustSnow.startTime = 0;
JustSnow.stopTime = {};
JustSnow.elapsedTime = 0;
JustSnow.lastPercentage = 0;
JustSnow.pricePerLitre = 0.025;
JustSnow.pricePerLitre_Salt = 0.99;
JustSnow.delay = 0;
JustSnow.delayTime = 120;
JustSnow.snowFactor = 2.0;
JustSnow.dropLength = 32;
JustSnow.sndVolume = 0.25;
JustSnow.sndVolumeQ = 0.11;
JustSnow.snowSndQ = false;
JustSnow.snowed = false;
JustSnow.snowingDF = false;
JustSnow.additionalSnow = false;
JustSnow.snowUpdated = false;
JustSnow.sizeDetermined = false;
JustSnow.snowfallLoaded = false;
JustSnow.allowsSmoothing = true;
JustSnow.allowsSmoothing_Salt = false;
JustSnow.useKeys = true;
JustSnow.debug = false;
JustSnow.addSnowText = "Adding Snow";
JustSnow.timeRemainingText = "Time remaining";
JustSnow.completeText = "complete";
JustSnow.bgOL = createImageOverlay(g_currentModDirectory.."res/background.dds");
JustSnow.barOL = createImageOverlay(g_currentModDirectory.."res/background.dds");
JustSnow.snowSnd = createSample("snowFallSound");
JustSnow.completeSnd = createSample("snowCompleteSound");
loadSample(JustSnow.snowSnd, JustSnow.dir.."res/snow_loop.ogg", false);
loadSample(JustSnow.completeSnd, JustSnow.dir.."res/success.ogg", false);
addModEventListener(JustSnow);
---------------------------------------------------------------------------------------

function JustSnow:initialize()
	g_currentMission.JustSnow_SnowFall = {};
	g_currentMission.JustSnow_SnowFall.node = loadI3DFile(JustSnow.dir.."res/snowing.i3d", false, false, false);
	g_currentMission.JustSnow_SnowFall.mistNode = getChildAt(g_currentMission.JustSnow_SnowFall.node,1);
	g_currentMission.JustSnow_SnowFall.node = getChildAt(g_currentMission.JustSnow_SnowFall.node,0);
	link(getRootNode(),g_currentMission.JustSnow_SnowFall.node);
	link(getRootNode(),g_currentMission.JustSnow_SnowFall.mistNode);
	local snowFallVisibility = true;
	playSample(JustSnow.snowSnd,0,JustSnow.sndVolume,0,0,0);
	JustSnow.snowfallLoaded = true;	
end;

function JustSnow:addMoreSnow()
	if not JustSnow.additionalSnow then
		JustSnow.totalDrops = 0;
		for _, stopTime in pairs(JustSnow.stopTime) do
			if stopTime.reStartTime == nil then 
				stopTime.reStartTime = g_time/1000; 
			end;
		end;
		JustSnow.snowed = false;
		JustSnow.snowingDF = true;
		JustSnow.additionalSnow = true;
	end;
end;

function JustSnow:stopAddingSnow(reset)
	local tD = JustSnow.totalDrops;
	if reset then
		JustSnow.snowed = true;
		JustSnow.snowingDF = false;	
		JustSnow.additionalSnow = false;
		JustSnow.x = 0;
		JustSnow.z = 0;
		JustSnow.totalDrops = 0;
		JustSnow.startTime = 0;
		JustSnow.stopTime = {};
		JustSnow.elapsedTime = 0;
		JustSnow.lastPercentage = 0;
		JustSnow.savegameTime = nil;
		JustSnow.savegameElapsedTime = nil;
		JustSnow:playCompleteSound();
	elseif JustSnow.additionalSnow then	
		JustSnow.snowed = true;
		JustSnow.snowingDF = false;
		JustSnow.additionalSnow = false;
		JustSnow.totalDrops = 0;
		if #JustSnow.stopTime > 0 then
			for i, stopTime in pairs(JustSnow.stopTime) do
				if stopTime.reStartTime == nil then 
					table.remove(JustSnow.stopTime, i);
				end;
			end;
		end;
		table.insert(JustSnow.stopTime, {g_time/1000});
	end;
	if JustSnow.debug then
		if not reset then JustSnow:playCompleteSound(); end;
		local duration = (JustSnow.startTime-(g_time/1000))/60;
		print(JustSnow.title.." :: "..tD.."Total time: "..duration); 
	end;
end;

function JustSnow:toggleSnowfall()
	JustSnow.snowingDF = not JustSnow.snowingDF;
end;

function JustSnow:toggleSnowInputKeys()
	JustSnow.useKeys = not JustSnow.useKeys;
	JustSnow.toggledKeyDelay = nil;
end;

function JustSnow:cutAllGrass()
	local allowsForageGrowthState = true;
	local size = getTerrainSize(g_currentMission.terrainRootNode);		
	FSDensityMapUtil.cutFruitArea(FruitType.GRASS, -size,-size,size,-size,-size,size, false, false, allowsForageGrowthState);
end;

function JustSnow:clearAllSnow()
	local size = getTerrainSize(g_currentMission.terrainRootNode);		
	DensityMapHeightUtil.removeFromGroundByArea(-size,-size,size,-size,-size,size, FillType.SNOW);
end;

function JustSnow:clearAllSalt()
	local size = getTerrainSize(g_currentMission.terrainRootNode);		
	DensityMapHeightUtil.removeFromGroundByArea(-size,-size,size,-size,-size,size, FillType.SALT);
end;

function JustSnow:setVolume(force)
	local dayMinutes = g_currentMission.environment.dayTime/(1000*60);
	local nightTime = (dayMinutes > (19*60) or dayMinutes < (6*60));
	if nightTime then
		if not JustSnow.snowSndQ or force then
			setSampleVolume(JustSnow.snowSnd,JustSnow.sndVolumeQ);
			JustSnow.snowSndQ = true;
		end;
	else
		if JustSnow.snowSndQ or force then
			setSampleVolume(JustSnow.snowSnd,JustSnow.sndVolume);
			JustSnow.snowSndQ = false;
		end;
	end;
end;

function JustSnow:loadSnow()
    local hudOverlayFilename = "res/hud_fill_snow.png";
    local hudOverlayFilenameSmall = "res/hud_fill_snow_sml.png";
	local showOnPriceTable = true;
    local massPerLiter = 0.00016;
    local snowDesc = g_fillTypeManager:addFillType("snow", g_i18n:getText("fillType_snow"), showOnPriceTable, JustSnow.pricePerLitre, massPerLiter, math.rad(38), hudOverlayFilename, hudOverlayFilenameSmall, JustSnow.dir, nil, { 1, 1, 1 }, nil, false);

    g_fillTypeManager:addFillTypeToCategory(snowDesc.index, g_fillTypeManager.nameToCategoryIndex["BULK"]);
	--[[for _, category in pairs ({'BULK','AUGERWAGON','TRAINWAGON','FARMSILO','LOADINGVEHICLE'}) do
		g_fillTypeManager:addFillTypeToCategory(snowDesc.index, g_fillTypeManager.nameToCategoryIndex[category]);
	end;]]

    local diffuseMapFilename = JustSnow.dir.."res/snow_diffuse.png";
    local normalMapFilename = JustSnow.dir.."res/snow_normal.png";
    local distanceMapFilename = JustSnow.dir.."res/snowDistance_diffuse.png";

    g_currentMission.snowHeightType = g_densityMapHeightManager:addDensityMapHeightType("snow", math.rad(38), 0.8, 0.10, 0.10, 1.20, 2, JustSnow.allowsSmoothing, diffuseMapFilename, normalMapFilename, distanceMapFilename, false);
   	if g_currentMission.snowHeightType == nil then
        print("Could not create the snow height type. The combination of map and mods are not compatible");
        return;
    end;

	g_particleSystemManager:addParticleType("snow");
    g_particleSystemManager:addParticleType("snow_smoke");
    g_particleSystemManager:addParticleType("snow_chunks");
    g_particleSystemManager:addParticleType("snow_big_chunks");
	
    local snowMaterialHolderFilename = Utils.getFilename("res/snowMaterialHolder.i3d", JustSnow.dir);
    g_currentMission.snowMaterialHolder = loadI3DFile(snowMaterialHolderFilename, false, true, false);

    local snowParticleMaterialHolderFileName = Utils.getFilename("res/snowParticleMaterialHolder.i3d", JustSnow.dir);
    g_currentMission.snowParticleMaterialHolder = loadI3DFile(snowParticleMaterialHolderFileName, false, true, false);

	return snowDesc;
end;

function JustSnow:loadSalt()
    local hudOverlayFilename = "res/hud_fill_salt.png";
    local hudOverlayFilenameSmall = "res/hud_fill_salt_sml.png";
    local massPerLiter = 0.00217;
	local showOnPriceTable = true;

    local saltDesc = g_fillTypeManager:addFillType("salt", g_i18n:getText("fillType_salt"), showOnPriceTable, JustSnow.pricePerLitre_Salt, massPerLiter, math.rad(32), hudOverlayFilename, hudOverlayFilenameSmall, JustSnow.dir, nil, { 1, 1, 1 }, nil, false);

    g_fillTypeManager:addFillTypeToCategory(saltDesc.index, g_fillTypeManager.nameToCategoryIndex["BULK"]);
	--for _, category in pairs ({'BULK','SPRAYER','SPREADER'}) do
	--	g_fillTypeManager:addFillTypeToCategory(saltDesc.index, g_fillTypeManager.nameToCategoryIndex[category]);
	--end;

    local diffuseMapFilename = JustSnow.dir.."res/salt_diffuse.png";
    local normalMapFilename = JustSnow.dir.."res/salt_normal.png";
    local distanceMapFilename = JustSnow.dir.."res/saltDistance_diffuse.png";

    g_currentMission.saltHeightType = g_densityMapHeightManager:addDensityMapHeightType("salt", math.rad(32), 0.8, 0.10, 0.10, 0.9, 1, JustSnow.allowsSmoothing_Salt, diffuseMapFilename, normalMapFilename, distanceMapFilename, false);
    if g_currentMission.saltHeightType == nil then
        Logging.error("Could not create the salt height type. The combination of map and mods are not compatible")
        return
    end

    local saltMaterialHolderFilename = Utils.getFilename("res/saltMaterialHolder.i3d", JustSnow.dir);
    g_currentMission.saltMaterialHolder = loadI3DFile(saltMaterialHolderFilename, false, true, false);
	
	return saltDesc;
end

function JustSnow:update()
	if not JustSnow.snowed then
		if not JustSnow.sizeDetermined then
			if JustSnow.delay < JustSnow.delayTime then 
				JustSnow.delay=JustSnow.delay+1; 
				return;
			end;
			JustSnow.terrainSize = getTerrainSize(g_currentMission.terrainRootNode)/2.0;
			local dLFactor = 1;
			--if GS_IS_CONSOLE_VERSION then dLFactor = 4; end;
			if self.isDedicatedServer then dLFactor = 2; end;
			JustSnow.dropLength = JustSnow.dropLength*dLFactor;
			JustSnow.sizeDetermined = true;
			--if JustSnow.Debug then print(JustSnow.title.." : Snow has started."); end;
		end;
		local size = JustSnow.terrainSize;
		JustSnow:processSnow(self, size, JustSnow.dropLength, g_currentMission.terrainRootNode);
		JustSnow.totalDrops = JustSnow.totalDrops+1;
		if JustSnow.z >= size then
			JustSnow:stopAddingSnow(true);
			--[[if JustSnow.debug then print(JustSnow.title.." :: "..JustSnow.totalDrops); end;
			JustSnow.snowed = true;
			JustSnow.additionalSnow = false;
			JustSnow.snowingDF = false;
			JustSnow.totalDrops = 0;
			JustSnow.x = 0;
			JustSnow.z = 0;]]
		end;
		if JustSnow.useKeys then
			if Input.isKeyPressed(Input.KEY_lctrl) then
				if Input.isKeyPressed(Input.KEY_lshift) then
					if JustSnow.toggledKeyDelay == nil and  Input.isKeyPressed(Input.KEY_delete) then
						JustSnow.toggledKeyDelay = 18;
						JustSnow:stopAddingSnow();
					end;
				end;
			end;
		end;
	else
		if JustSnow.useKeys then
			if Input.isKeyPressed(Input.KEY_lctrl) then
				if Input.isKeyPressed(Input.KEY_lshift) then
					if JustSnow.toggledKeyDelay == nil and Input.isKeyPressed(Input.KEY_insert) then
						JustSnow.toggledKeyDelay = 18;
						JustSnow:addMoreSnow();
					end;
				end;
			end;
		end;
	end;
	
	if JustSnow.useKeys then
		if Input.isKeyPressed(Input.KEY_lctrl) then
			if Input.isKeyPressed(Input.KEY_lshift) then
				if JustSnow.toggledKeyDelay == nil and Input.isKeyPressed(Input.KEY_end) then
					JustSnow.toggledKeyDelay = 18;
					JustSnow:toggleSnowfall();
				end;
			end;
		end;
		----------------
		if JustSnow.toggledKeyDelay ~= nil then
			JustSnow.toggledKeyDelay = JustSnow.toggledKeyDelay - 1;
			if JustSnow.toggledKeyDelay <= 0 then JustSnow.toggledKeyDelay = nil; end;
		end;
	end;

	if not JustSnow.snowfallLoaded then
		JustSnow:initialize();
	end;
	
	if not JustSnow.snowingDF or g_gui:getIsGuiVisible() or JustSnow:getIsRaining() then
		if JustSnow:getSnowFallVisibility() then
			JustSnow:setSnowFallVisibility(false);
			setSampleVolume(JustSnow.snowSnd,0);
			Wipers.forcedState = 0;
		end;
	else
		if not JustSnow:getSnowFallVisibility() then
			JustSnow:setSnowFallVisibility(true);	
			JustSnow:setVolume(true);
			Wipers.forcedState = 1;
		end;
		JustSnow:setVolume(false);
	end;
	
end;

function JustSnow:playCompleteSound()
	--if not getIsSamplePlaying(JustSnow.completeSnd) then
		local volume = 0.2;
		local playCount = 1;
		playSample(JustSnow.completeSnd,playCount,volume,0,0,0);
	--end;
end;

function JustSnow:isOnField(x,y,z)
	--{the length of the drops would have to be 1x1 for this to work right}
	local bits = getDensityAtWorldPos(g_currentMission.terrainDetailId,x,y,z);
	if bits ~= 0 then
		return true;
	end;
	return false;
end;

function JustSnow:removeGrass(xs,ys,zs,xw,yw,zw)
	if JustSnow.cutGrass then
		local allowsForageGrowthState = true;
		--if not (JustSnow:isOnField(xs,ys,zs) and JustSnow:isOnField(xw,yw,zw)) then 
		FSDensityMapUtil.cutFruitArea(FruitType.GRASS, xs,zs+0.25, xw,zw+0.25, xw,zw-0.25, false, false, allowsForageGrowthState);
		--end;
	end;
end;

function JustSnow:getSnowFallVisibility()	
	if g_currentMission.JustSnow_SnowFall ~= nil  then
		return getVisibility(g_currentMission.JustSnow_SnowFall.node);
	else
		return false;
	end;
end;

function JustSnow:setSnowFallVisibility(isVisible)	
	if g_currentMission.JustSnow_SnowFall ~= nil then
		setVisibility(g_currentMission.JustSnow_SnowFall.node,isVisible);
		setVisibility(g_currentMission.JustSnow_SnowFall.mistNode,isVisible);
	end;
end;

function JustSnow:processSnow(self, size, dropLength, terrainNode)
	local dumpAmount = JustSnow.snowFactor*1000;
	local i = 0;
	local oPO = 0.001; --overlap prevenitive offset
	while JustSnow.z < size do
		local x = JustSnow.x;
		local z = JustSnow.z;
		if x < (size-dropLength) then
			x = x+dropLength;
		elseif z < size then
			z = z+0.5;
			x = 0;
		end;
		JustSnow.x = x; 
		JustSnow.z = z;
		local y1 = getTerrainHeightAtWorldPos(terrainNode, x,100.0,z)+JustSnow.yBoost;
		local y2 = getTerrainHeightAtWorldPos(terrainNode, x+dropLength,100.0,z)+JustSnow.yBoost;
		DensityMapHeightUtil.tipToGroundAroundLine(self, dumpAmount, FillType.SNOW, x,y1,z, x+dropLength-oPO,y2,z, 0, nil, 0, false, nil, false);
		JustSnow:removeGrass(x,y1,z, x+dropLength,y2,z);
		--
		y1 = getTerrainHeightAtWorldPos(terrainNode, -x,100.0,z)+JustSnow.yBoost;
		y2 = getTerrainHeightAtWorldPos(terrainNode, -(x+dropLength),100.0,z)+JustSnow.yBoost;
		DensityMapHeightUtil.tipToGroundAroundLine(self, dumpAmount, FillType.SNOW, -x,y1,z, -(x+dropLength-oPO),y2,z, 0, nil, 0, false, nil, false);
		JustSnow:removeGrass(-x,y1,z, -(x+dropLength),y2,z);
		--
		if z > 0 then
			y1 = getTerrainHeightAtWorldPos(terrainNode, x,100.0,-z)+JustSnow.yBoost;
			y2 = getTerrainHeightAtWorldPos(terrainNode, x+dropLength,100.0,-z)+JustSnow.yBoost;
			DensityMapHeightUtil.tipToGroundAroundLine(self, dumpAmount, FillType.SNOW, x,y1,-z, x+dropLength-oPO,y2,-z, 0, nil, 0, false, nil, false);
			JustSnow:removeGrass(x,y1,-z, x+dropLength,y2,-z);
			--
			y1 = getTerrainHeightAtWorldPos(terrainNode, -x,100.0,-z)+JustSnow.yBoost;
			y2 = getTerrainHeightAtWorldPos(terrainNode, -(x+dropLength),100.0,-z)+JustSnow.yBoost;
			DensityMapHeightUtil.tipToGroundAroundLine(self, dumpAmount, FillType.SNOW, -x,y1,-z, -(x+dropLength-oPO),y2,-z, 0, nil, 0, false, nil, false);
			JustSnow:removeGrass(-x,y1,-z, -(x+dropLength),y2,-z);
			--
		end;
		if i>(size/JustSnow.tipsPerTic) or JustSnow.additionalSnow or g_gui:getIsGuiVisible() then break; end;
		i=i+1;
	end;
end;

function JustSnow:draw()	
	if not JustSnow.snowfallLoaded then return end;
	if not JustSnow.snowed then
		local uiScale = g_gameSettings:getValue("uiScale");
		local textSize = 0.015*uiScale;
		local oX = textSize * HUDTextDisplay.SHADOW_OFFSET_FACTOR;
		local loadPercent = 0;
		if JustSnow.z > 0 then loadPercent = math.floor((JustSnow.z/JustSnow.terrainSize)*1000)/10; end;
		if loadPercent > 100 then loadPercent = 0; end;
		if JustSnow.additionalSnow then
			local gameTime = g_time/1000;
			if JustSnow.savegameTime ~= nil then gameTime = gameTime+JustSnow.savegameTime; end;
			if JustSnow.startTime <= 0 then	JustSnow.startTime=gameTime; end;
			if #JustSnow.stopTime > 0 then
				local pauseGaps = 0;
				for _, stopTime in pairs(JustSnow.stopTime) do
					if stopTime.reStartTime == nil then	stopTime.reStartTime = gameTime; end;
					pauseGaps = pauseGaps+(stopTime.reStartTime-unpack(stopTime));
				end;
				gameTime = gameTime-pauseGaps;
			end;
			if JustSnow.lastPercentage < loadPercent then --only update when vars change
				JustSnow.elapsedTime = math.floor(gameTime-JustSnow.startTime);
				JustSnow.lastPercentage = loadPercent;
			end;
			local elapsedTime = JustSnow.elapsedTime;			
			local timeUntilComplete = math.floor((((elapsedTime/loadPercent)*(101-loadPercent))-elapsedTime)/6)/10;
			if timeUntilComplete <= 0 or loadPercent < 0.1 then timeUntilComplete = "~ "; end;
			local renderString = JustSnow.addSnowText.." : "..math.max(loadPercent,0.0).."% "..JustSnow.completeText;
			local timeString = JustSnow.timeRemainingText.." : "..timeUntilComplete.."mins";--..elapsedTime
			local w = 0.12;
			local h = 0.02*g_screenAspectRatio;
			local screenXY = {0.5,1-0.025}
			local x = screenXY[1]-(w/2);
			local y = screenXY[2]-(h/2);
			renderOverlay(JustSnow.bgOL, x,y,w,h);
			hy = h-(h*0.1);
			h = h-((h*0.1)*2);
			x = x+(w*0.02);
			y = y+(hy*0.1);
			w = math.min(w*0.98,(w*0.98)*(loadPercent/100));
			renderOverlay(JustSnow.barOL, x,y,w,h);
			setTextBold(false);
			setTextColor(0,0,0,1);
			setTextAlignment(RenderText.ALIGN_CENTER);
			renderText(screenXY[1]+oX,(screenXY[2]+(textSize*0.25))-oX, textSize, renderString);
			renderText(screenXY[1]+oX,(screenXY[2]-textSize)-oX, textSize, timeString);
			setTextColor(1,1,1,1);
			renderText(screenXY[1],screenXY[2]+(textSize*0.25), textSize, renderString);
			renderText(screenXY[1],screenXY[2]-textSize, textSize, timeString);
			if loadPercent >= 100 then 
				JustSnow.startTime = 0;
				JustSnow.stopTime = {};
				JustSnow.elapsedTime = 0;
				JustSnow.lastPercentage = 0;
			end;
		else
			textSize = 0.02*uiScale;
			local gameTime = g_time/1000;
			if loadPercent == 1.0 then JustSnow.startTime = gameTime; end; -- based off time since game start
			local timeUntilComplete = math.floor((JustSnow.startTime*(100-loadPercent))/60)/10;
			if timeUntilComplete <= 0 then timeUntilComplete = "-"; end;
			local renderString = JustSnow.addSnowText.." : "..math.max(loadPercent,0.0).."% "..JustSnow.completeText;
			local timeString = JustSnow.timeRemainingText.." : "..timeUntilComplete.."mins";
			local w = 0.25;
			local h = 0.05*g_screenAspectRatio;
			local x = 0.5-(w/2);
			local y = 0.5-(h/2);
			renderOverlay(JustSnow.bgOL, x,y,w,h);
			hy = h-(h*0.1);
			h = h-((h*0.1)*2);
			x = x+(w*0.1);
			y = y+(hy*0.1);
			w = math.min(w*0.8,(w*0.8)*(loadPercent/100));
			renderOverlay(JustSnow.barOL, x,y,w,h);
			setTextBold(false);
			setTextColor(0,0,0,1);
			setTextAlignment(RenderText.ALIGN_CENTER);
			renderText(0.5+oX,(0.5+textSize)-oX, textSize, renderString);
			renderText(0.5+oX,(0.5-textSize)-oX, textSize, timeString);
			setTextColor(1,1,1,1);
			renderText(0.5,0.5+textSize, textSize, renderString);
			renderText(0.5,0.5-textSize, textSize, timeString);
			if loadPercent >= 100 then
				JustSnow.startTime = 0;
				JustSnow.stopTime = {};
				JustSnow.elapsedTime = 0;
				JustSnow.lastPercentage = 0;
			end;
		end;
	end;
end;

function JustSnow:saveSettings()
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory.."/";
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), g_currentMission.missionInfo.savegameIndex.."/");
	end;
	local key = "justSnow";
	local xmlFile = createXMLFile(key, savegameFolderPath.."justSnow.xml", key);
	local runningTime = JustSnow.stopTime;
	local z = JustSnow.z;
	if z >= JustSnow.terrainSize then z = 0; end;
	if JustSnow.snowed or JustSnow.additionalSnow then
		--table.insert(JustSnow.stopTime,{g_time/1000});
		local timeSend = g_time/1000;
		if JustSnow.savegameTime ~= nil then
			timeSend = timeSend + JustSnow.savegameTime;
		end;
		setXMLInt(xmlFile, key..".gameTime", timeSend);
	end;
	
	if #JustSnow.stopTime > 0 then
		local pauseGaps = 0;
		for i, stopTime in pairs(JustSnow.stopTime) do
			setXMLInt(xmlFile, key..".stopTime"..i, unpack(stopTime));
			if stopTime.reStartTime ~= nil then
				setXMLInt(xmlFile, key..".reStartTime"..i, stopTime.reStartTime);
			end;
		end;
	end;

	setXMLBool(xmlFile, key..".snowHasFallen#value", JustSnow.snowed);
	setXMLBool(xmlFile, key..".snowIsFalling#value", JustSnow.additionalSnow);
	setXMLInt(xmlFile, key..".startTime", JustSnow.startTime);
	--setXMLInt(xmlFile, key..".lastPercentage", JustSnow.lastPercentage);
	--setXMLInt(xmlFile, key..".elapsedTime", JustSnow.elapsedTime);
	setXMLInt(xmlFile, key..".snowLastUV#x", JustSnow.x);
	setXMLInt(xmlFile, key..".snowLastUV#z", JustSnow.z);
	setXMLBool(xmlFile, key..".snowingDF", JustSnow.snowingDF);
	setXMLBool(xmlFile, key..".useKeyInputs",JustSnow.useKeys);
	saveXMLFile(xmlFile);
	delete(xmlFile);
end;

function JustSnow:loadMap(savegame)
	if JustSnow:incompatible() then return; end;
	FSBaseMission.saveSavegame = Utils.appendedFunction(FSBaseMission.saveSavegame, JustSnow.saveSettings);
	local snowDesc = JustSnow:loadSnow();
	if JustSnow.loadSalt then JustSnow.loadSalt(); end;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), g_currentMission.missionInfo.savegameIndex);
	end;
	if fileExists(savegameFolderPath.."/justSnow.xml") then 
		local xmlFile = loadXMLFile("justSnow", savegameFolderPath.."/justSnow.xml");
		local key = "justSnow";
		JustSnow.snowed = Utils.getNoNil(getXMLBool(xmlFile, key..".snowHasFallen#value"),false);
		JustSnow.additionalSnow = Utils.getNoNil(getXMLBool(xmlFile, key..".snowIsFalling#value"),false);
		JustSnow.startTime = Utils.getNoNil(getXMLInt(xmlFile, key..".startTime"), JustSnow.startTime);
		--JustSnow.elapsedTime = Utils.getNoNil(getXMLInt(xmlFile, key..".elapsedTime"), JustSnow.elapsedTime);
		--JustSnow.lastPercentage = Utils.getNoNil(getXMLInt(xmlFile, key..".lastPercentage"), JustSnow.lastPercentage);
		JustSnow.x = Utils.getNoNil(getXMLInt(xmlFile, key..".snowLastUV#x"),JustSnow.x);
		JustSnow.z = Utils.getNoNil(getXMLInt(xmlFile, key..".snowLastUV#z"),JustSnow.z);
		JustSnow.snowingDF = Utils.getNoNil(getXMLBool(xmlFile, key..".snowingDF"),true);
		JustSnow.useKeys = Utils.getNoNil(getXMLBool(xmlFile, key..".useKeyInputs"),true);
		JustSnow.savegameTime = Utils.getNoNil(getXMLInt(xmlFile, key..".gameTime"),nil);
		if JustSnow.savegameTime ~= nil then table.insert(JustSnow.stopTime,{JustSnow.savegameTime}); end;
		i=1;
		while (true) do
			local stopTime = Utils.getNoNil(getXMLInt(xmlFile, key..".stopTime"..i),nil);
			if stopTime == nil then break; end;
			table.insert(JustSnow.stopTime, {stopTime});
			i=i+1;
		end;
		if #JustSnow.stopTime > 0 then
			for i, stopTime in pairs(JustSnow.stopTime) do
				local reStartTime = Utils.getNoNil(getXMLInt(xmlFile, key..".reStartTime"..i),nil);
				if reStartTime ~= nil then 
					stopTime.reStartTime = reStartTime;
				else
					JustSnow.savegameTime = unpack(stopTime)*-1;
				end;
			end;
		end;
		delete(xmlFile);
	else
		if not JustSnow.fullCPULoad then JustSnow.additionalSnow = true; end;
		JustSnow.snowingDF = true;
	end;
	
	JustSnow.addSnowText = g_i18n:getText("js_addingSnow");
	JustSnow.timeRemainingText = g_i18n:getText("js_timeRemaining");
	JustSnow.completeText = g_i18n:getText("js_complete");

	setOverlayColor(JustSnow.bgOL, 0, 0, 0, 0.94);
	setOverlayColor(JustSnow.barOL, 0.2, 0.4, 0.6, 1.0);

    addConsoleCommand("addSnow", g_i18n:getText("js_addSnowCC"), "addMoreSnow", self);
	addConsoleCommand("stopSnow", g_i18n:getText("js_stopSnowCC"), "stopAddingSnow", self);
    addConsoleCommand("toggleSnowWeather", g_i18n:getText("js_toggleWeatherCC"), "toggleSnowfall", self);
    addConsoleCommand("toggleSnowKeys", g_i18n:getText("js_toggleKeysCC"), "toggleSnowInputKeys", self);
	addConsoleCommand("trimAllGrass", g_i18n:getText("js_trimGrassCC"), "cutAllGrass", self);
    addConsoleCommand("removeAllSnow", g_i18n:getText("js_removeSnowCC"), "clearAllSnow", self);
	addConsoleCommand("removeAllSalt", g_i18n:getText("js_removeSaltCC"), "clearAllSalt", self);

	g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager);
	
	print("Load mod: "..JustSnow.title.." : v"..JustSnow.version.." by "..JustSnow.author);
	if JustSnow.Debug then print("Load complete. Snow: "..snowDesc.name..":"..FillType.SNOW.."("..snowDesc.index..")"); end;
end;

function JustSnow:delete()
	if JustSnow.snowfallLoaded then
		removeConsoleCommand("addSnow");
        removeConsoleCommand("stopSnow");
        removeConsoleCommand("toggleSnowWeather");
        removeConsoleCommand("toggleSnowKeys");
        removeConsoleCommand("trimAllGrass");
        removeConsoleCommand("removeAllSnow");
        removeConsoleCommand("removeAllSalt");
	end;
end;

function JustSnow:incompatible()
	local incompatible = g_modIsLoaded["FS19_RM_Seasons"];
	if incompatible then
		print("! Incompatible Mod : 'Seasons' Detected ! Aborting..");
		removeModEventListener(JustSnow);
	end;
	return incompatible;
end;

function JustSnow:getIsRaining()
	return g_currentMission.environment.weather:getIsRaining();
end;

function JustSnow:createWeatherIcon(superFunction, hudAtlasPath, weatherId, boxHeight, uvs, color)
    local width, height = self:scalePixelToScreenVector(GameInfoDisplay.SIZE.WEATHER_ICON);
	hudAtlasPath = JustSnow.dir.."res/hud_elements.png";
    local overlay = Overlay:new(hudAtlasPath, 0, 0, width, height);
    overlay:setUVs(getNormalizedUVs(uvs));
    local element = HUDElement:new(overlay);
    element:setVisible(false);
    return element;
end;

if not JustSnow:incompatible() then
	GameInfoDisplay.createWeatherIcon = Utils.overwrittenFunction(GameInfoDisplay.createWeatherIcon, JustSnow.createWeatherIcon);
end;